using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace Lianxi1
{
    class Program
    {
        static void Main(string[] args)
        {
            IPEndPoint localEP = new IPEndPoint(IPAddress.Parse("127.0.0.1"), 8888);
            TcpListener listener = new TcpListener(localEP);
            listener.Start(10);
            Console.WriteLine("listening...");

            while (true)
            {
                TcpClient client = listener.AcceptTcpClient();

                if (client.Connected)
                {
                    WorkerProc proc = new WorkerProc();
                    proc.Client = client;

                    Thread t = new Thread(new ThreadStart(proc.Run));
                    t.IsBackground = true;
                    t.Start();
                }
            }
        }
    }

    class WorkerProc
    {
        private TcpClient _client;
        public TcpClient Client
        {
            set { this._client = value; }
        }

        public void Run()
        {
            NetworkStream netStream = _client.GetStream();
            StreamReader sr = new StreamReader(netStream, Encoding.UTF8);
            string s = String.Empty;

            do
            {
                s = sr.ReadLine();
                if (s == null)
                    break;
                Console.WriteLine(s);
            } while (!s.Equals("quit"));

            sr.Close();
            _client.Close();
        }
    }
}
