using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace GuiClient
{
    /// <summary>
    /// tH[̃b`eLXg{bNXXV̂߂delegate
    /// </summary>
    /// <param name="s"></param>
    delegate void SamDelegate(string s);

    public partial class Form1 : Form
    {
        TcpClient client;
        NetworkStream netStream;
        StreamReader sr;
        StreamWriter sw;
        const string CRLF = "\r\n";

        public Form1()
        {
            InitializeComponent();

            buttonSend.Enabled = false;
            buttonStop.Enabled = false;
        }

        public void SetText(string s)
        {
            richTextBoxShow.AppendText(s + CRLF);
        }

        /// <summary>
        /// X^bg{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonStart_Click(object sender, EventArgs e)
        {
            try
            {
                client = new TcpClient(textBoxIP.Text, int.Parse(textBoxPort.Text));

                netStream = client.GetStream();

                sr = new StreamReader(netStream, Encoding.UTF8);
                sw = new StreamWriter(netStream, Encoding.UTF8);
                sw.AutoFlush = true;

                buttonStart.Enabled = false;
                buttonStop.Enabled = true;
                buttonSend.Enabled = true;

                SetText("ڑ܂");
            }
            catch
            {
                SetText("ڑł܂");
            }
        }

        /// <summary>
        /// Xgbv{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonStop_Click(object sender, EventArgs e)
        {
            try
            {
                sr.Close();
                sw.Close();
                netStream.Close();
                client.Close();
                SetText("RlNVؒf܂");
            }
            catch
            {
                SetText("RlNV̐ؒf͎s܂");
            }

            buttonStart.Enabled = true;
            buttonStop.Enabled = false;
            buttonSend.Enabled = false;
        }

        /// <summary>
        /// M{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSend_Click(object sender, EventArgs e)
        {
            SendData(textBoxMsg.Text);
        }

        /// <summary>
        /// MXbhN郁\bh
        /// </summary>
        /// <param name="s">M镶</param>
        private void SendData(string s)
        {
            WorkProce wp = new WorkProce(this);
            wp.SR = sr;
            wp.SW = sw;
            wp.Data = s;

            Thread t = new Thread(new ThreadStart(wp.SendToServer));
            t.IsBackground = true;
            t.Start();
        }
    }

    /// <summary>
    /// MNX
    /// </summary>
    public class WorkProce
    {
        private Form1 _form;

        private StreamReader _sr;
        private StreamWriter _sw;
        private string _data;

        /// <summary>
        /// MpStreamReader
        /// </summary>
        public StreamReader SR
        {
        set { _sr = value; }
        }

        /// <summary>
        /// MpStreamWriter
        /// </summary>
        public StreamWriter SW
        {
        set { _sw = value; }
        }

        /// <summary>
        /// Mf[^̕
        /// </summary>
        public string Data
        {
        set { _data = value; }
        }

        public WorkProce(Form1 form)
        {
            _form = form;
        }

        public void SendToServer()
        {
            try
            {
                _sw.WriteLine(_data);
                string s = _sr.ReadLine();
                _form.Invoke(new SamDelegate(_form.SetText), s);
            }
            catch
            {
                _form.Invoke(new SamDelegate(_form.SetText), "Mł܂ł");
            }
        }
    }
}