using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace SocketClient
{
    delegate void SamDelegate(string s);

    public partial class Form1 : Form
    {
        Socket s;
        WorkProc proc;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            btnSend.Enabled = false;
            btnStart.Enabled = true;
            btnStop.Enabled = false;
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            try
            {
                IPAddress addr = Dns.GetHostAddresses(textBoxIP.Text)[0];

                IPEndPoint serverEP = new IPEndPoint(addr, int.Parse(textBoxPort.Text));
                s = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                s.Connect(serverEP);

                if (s.Connected)
                {
                    SetText("Connected to server " + textBoxIP.Text + "\r\n");
                }

                proc = new WorkProc(s, this);

                btnStop.Enabled = true;
                btnStart.Enabled = false;
                btnSend.Enabled = true;
            }
            catch (Exception ex)
            {
                SetText(ex.Message);
            }
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            try
            {
                s.Shutdown(SocketShutdown.Both);
                s.Close();
                btnStop.Enabled = false;
                btnStart.Enabled = true;
                btnSend.Enabled = false;
            }
            catch
            {
            }
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            proc.Data = textBoxMsg.Text;
            Thread t = new Thread(new ThreadStart(proc.SendToServer));
            t.IsBackground = true;
            t.Start();
        }

        public void SetText(string s)
        {
            rTboxShow.AppendText(s);
        }
    }

    public class WorkProc
    {
        Socket _s;
        Form1 _form;

        public WorkProc(Socket s, Form1 form)
        {
            _s = s;
            _form = form;
        }

        private string _data;
        public string Data
        {
            set { _data = value + "\r\n"; }
        }

        public void SendToServer()
        {
            byte[] bb = Encoding.UTF8.GetBytes(_data);
            byte[] cc = new byte[1024];
            int bytes = 0;
            string rs = String.Empty;

            try
            {
                _s.Send(bb, bb.Length, SocketFlags.None);
                bytes = _s.Receive(cc, cc.Length, SocketFlags.None);

                rs = Encoding.UTF8.GetString(cc, 0, bytes);

                _form.Invoke(new SamDelegate(_form.SetText), rs);
            }
            catch
            {
                _form.Invoke(new SamDelegate(_form.SetText), "Ms");
            }
        }
    }
}