using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Collections;

namespace SocketServer
{
    delegate void SamDelegate(object obj);

    public partial class Form1 : Form
    {
        Form1 _form;
        public Form1(Form1 form)
        {
            InitializeComponent();
            _form = form;
        }

        public volatile bool flag = false;

        ArrayList Session = new ArrayList();
        int port = 0;
        public int Port
        {
            set { port = value; }
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            flag = true;

            Form1 Server = new Form1(this);
            Server.port = Int32.Parse(textBoxPort.Text);

            Thread t = new Thread(new ThreadStart(Server.StartServer));
            t.IsBackground = true;
            t.Start();

            btnStart.Enabled = false;
            btnStop.Enabled = true;
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            flag = false;

            try
            {
                TcpClient client = new TcpClient(GetLocalAddr().ToString(), Int32.Parse(textBoxPort.Text));
                client.Close();
            }
            catch
            {
            }

            /// ݐڑ̃\Pbg܂
            for (int i = Session.Count - 1; i >= 0; i--)
            {
                (Session[i] as WorkProc).socket.Shutdown(SocketShutdown.Both);
                (Session[i] as WorkProc).socket.Close();
            }

            btnStart.Enabled = true;
            btnStop.Enabled = false;
        }

        /// <summary>
        /// [JIPAhX擾܂
        /// </summary>
        /// <returns></returns>
        private IPAddress GetLocalAddr()
        {
            /// IPv4IPAhX݂̂擾܂
            foreach (IPAddress addr in Dns.GetHostAddresses(Dns.GetHostName()))
            {
                if (addr.AddressFamily == AddressFamily.InterNetwork)
                    return addr;
            }

            return IPAddress.Parse("127.0.0.1");
        }

        public void StartServer()
        {
            try
            {
                IPEndPoint ipEndPoint = new IPEndPoint(GetLocalAddr(), port);

                Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                socket.Bind(ipEndPoint);

                socket.Listen(10);

                while (true)
                {
                    Socket s = socket.Accept();

                    if (!_form.flag)
                    {
                        s.Close();
                        break;
                    }
                    if (s.Connected)
                    {
                        WorkProc proc = new WorkProc(_form);
                        proc.socket = s;
                        proc.ID = Guid.NewGuid();

                        Thread work = new Thread(new ThreadStart(proc.Run));
                        work.IsBackground = true;
                        work.Start();
                    }
                }
                socket.Close();
            }
            catch (Exception ex)
            {
            }
        }

        public void SetText(object obj)
        {
            rTboxShow.AppendText((string)obj);
        }

        public void AddSession(object obj)
        {
            Session.Add(obj);
        }

        public void RemoveSession(object obj)
        {
            for (int i = 0; i < Session.Count; i++)
            {
                if ((Session[i] as WorkProc).ID == (obj as WorkProc).ID)
                {
                    Session.RemoveAt(i);
                }
            }
        }
    }

    class WorkProc
    {
        Socket s;
        public Socket socket
        {
            set { s = value; }
            get { return s; }
        }

        Form1 _form;
        Guid id;

        public WorkProc(Form1 form)
        {
            _form = form;
        }

        public Guid ID
        {
            set { id = value; }
            get { return id; }
        }

        public void Run()
        {
            string msg = String.Empty;

            string ip = ((IPEndPoint)s.RemoteEndPoint).Address.ToString();
            _form.Invoke(new SamDelegate(_form.SetText), "Connected " + ip + "\r\n");
            _form.Invoke(new SamDelegate(_form.AddSession), this);

            int bytes = 0;
            byte[] bb = new byte[1024];

            try
            {
                do
                {
                    bytes = s.Receive(bb, bb.Length, SocketFlags.None);
                    s.Send(bb, bytes, SocketFlags.None);

                    msg = Encoding.UTF8.GetString(bb, 0, bytes);
                    _form.Invoke(new SamDelegate(_form.SetText), msg);
                }
                while (bytes > 0 && !msg.Equals("quit\r\n"));

                s.Shutdown(SocketShutdown.Both);
                s.Close();
            }
            catch (SocketException ex)
            {
            }

            _form.Invoke(new SamDelegate(_form.SetText), "Disconnected " + ip + "\r\n");
            _form.Invoke(new SamDelegate(_form.RemoveSession), this);
        }
    }
}