//////////////////////////////////////////
///
/// NetControl Ver: 1.5
/// Server Project
/// Copyright Sam Zhao
/// 2007 Tokyo Japan
///
//////////////////////////////////////////
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Collections;
using System.Threading;
using System.Runtime.InteropServices;
using System.Drawing.Imaging;
using System.Diagnostics;
using System.Management;

namespace NetServer
{
    delegate void SamDelegate(object obj);

    public partial class Form1 : Form
    {
        const string CRLF = "\r\n";
        /// <summary>
        /// T[oNA~tO
        /// </summary>
        public volatile bool flag = true;
        /// <summary>
        /// ׂẴRlNV̊Ǘ
        /// </summary>
        ArrayList Session = new ArrayList();

        /// <summary>
        /// CXi
        /// </summary>
        TcpListener listener;

        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// T[oN
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnStart_Click(object sender, EventArgs e)
        {
            btnStart.Enabled = false;
            btnStop.Enabled = true;

            flag = true;

            Thread tMain = new Thread(new ThreadStart(StartServer));
            tMain.IsBackground = true;
            tMain.Start();
        }

        /// <summary>
        /// T[o~
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnStop_Click(object sender, EventArgs e)
        {
            btnStart.Enabled = true;
            btnStop.Enabled = false;

            flag = false;

            for (int i = Session.Count - 1; i >= 0; i--)
            {
                try
                {
                    ((WorkerProc)Session[i]).Client.Close();
                }
                catch
                { }
            }
        }

        public void SetText(object obj)
        {
            rTboxShow.AppendText((string)obj + CRLF);
        }

        /// <summary>
        /// mς݂̃RlNVZbVXgɒǉ܂
        /// </summary>
        /// <param name="obj"></param>
        public void AddSession(object obj)
        {
            Session.Add(obj);
        }

        /// <summary>
        /// jς݂̃RlNVZbVXg폜܂
        /// </summary>
        /// <param name="obj"></param>
        public void RemoveSession(object obj)
        {
            for (int i = 0; i < Session.Count; i++)
            {
                try
                {
                    if (((WorkerProc)Session[i]).ID == ((WorkerProc)obj).ID)
                    {
                        Session.RemoveAt(i);
                        break;
                    }
                }
                catch
                {
                }
            }
        }

        /// <summary>
        /// tH[\邩Ȃ
        /// </summary>
        /// <param name="obj"></param>
        public void ShowHideForm(object obj)
        {
            if ((bool)obj)
            {
                this.Visible = true;
            }
            else
            {
                this.Visible = false;
            }
        }

        /// <summary>
        /// [JIPv4 IPAhX擾܂
        /// </summary>
        /// <returns>[JIPv4AhX</returns>
        private IPAddress GetLocalIPAddress()
        {
            foreach (IPAddress addr in Dns.GetHostAddresses(Dns.GetHostName()))
            {
                if (addr.AddressFamily == AddressFamily.InterNetwork)
                    return addr;
            }
            return IPAddress.Parse("127.0.0.1");
        }

        /// <summary>
        /// CXiN܂
        /// </summary>
        private void StartServer()
        {
            IPEndPoint localEP = new IPEndPoint(GetLocalIPAddress(), 1888);
            listener = new TcpListener(localEP);
            try
            {
                listener.Start(5);
                this.Invoke(new SamDelegate(this.SetText), "Server listening on " + GetLocalIPAddress().ToString());
            }
            catch (Exception ex)
            {
                this.Invoke(new SamDelegate(SetText), ex.Message);
                return;
            }

            while (flag)
            {
                if (listener.Pending())
                {
                    TcpClient client = listener.AcceptTcpClient();

                    if (client.Connected)
                    {
                        WorkerProc proc = new WorkerProc(this);
                        proc.Client = client;
                        proc.ID = Guid.NewGuid();

                        this.Invoke(new SamDelegate(AddSession), proc);

                        Thread t = new Thread(new ThreadStart(proc.Run));
                        t.IsBackground = true;
                        t.Start();
                    }
                }

                Thread.Sleep(50);
            }

            listener.Stop();
            this.Invoke(new SamDelegate(this.SetText), "Server Stoped");
        }
    }

    /// <summary>
    /// ʐMpNX
    /// </summary>
    public class WorkerProc
    {
        private volatile bool DoorOpened = false;

        Form1 _form;
        TcpClient _client;
        Guid _id;

        public WorkerProc(Form1 form)
        {
            _form = form;
        }

        /// <summary>
        /// ʐMpTcpClient
        /// </summary>
        public TcpClient Client
        {
            set { _client = value; }
            get { return _client; }
        }

        /// <summary>
        /// RlNV̎GUID
        /// </summary>
        public Guid ID
        {
            set { _id = value; }
            get { return _id; }
        }

        public void Run()
        {
            NetworkStream netStream = this._client.GetStream();
            IPEndPoint ipe = (IPEndPoint)this._client.Client.RemoteEndPoint;

            _form.Invoke(new SamDelegate(_form.SetText), "Connected from " + ipe.Address.ToString());

            StreamReader sr = new StreamReader(netStream, Encoding.UTF8);
            StreamWriter sw = new StreamWriter(netStream, Encoding.UTF8);
            sw.AutoFlush = true;

            string s = String.Empty;
            string rs = String.Empty;

            do
            {
                try
                {
                    s = sr.ReadLine();

                    if (s == null)
                        break;
                    string[] ss = s.Split(' ');
                    switch (ss[0])
                    {   /// fBNgƃt@CXg܂
                        case "list":
                            CmdList(ss[1], ref rs);
                            break;
                        /// w肵t@C폜܂
                        case "del":
                            CmdDel(ss[1], ref rs);
                            break;
                        /// w肵t@CNCAgɓ]܂
                        case "copy":
                            CmdCopy(ss[1], ref rs);
                            break;
                        /// T[õhCu擾܂
                        case "driverinfo":
                            CmdDriverInfo(ss[1], ref rs);
                            break;
                        /// T[oɃbZ[W𑗐M܂
                        case "msg":
                            CmdMsg(ss[1], ref rs);
                            break;
                        /// w肵AvP[VN܂
                        case "run":
                            CmdRunApp(ss[1], ref rs);
                            break;
                        /// w肵URLJ܂
                        case "url":
                            CmdGoToURL(ss[1], ref rs);
                            break;
                        /// T[õo[W擾܂
                        case "winversion":
                            CmdWinVer(ss[1], ref rs);
                            break;
                        /// CDhCuI[vEN[X
                        case "cdcontrol":
                            CmdCdControl(ss[1], ref rs);
                            break;
                        /// tH[\܂
                        case "ShowForm":
                            ShowForm(ss[1], ref rs);
                            break;
                        /// tH[B܂
                        case "HideForm":
                            HideForm(ss[1], ref rs);
                            break;
                        /// T[õXN[ʂ擾܂
                        case "getscreen":
                            CmdGetScreen(ss[1], ref rs);
                            break;
                        default:
                            break;
                    }

                    sw.WriteLine(rs);

                    _form.Invoke(new SamDelegate(_form.SetText), s);
                }
                catch
                {
                    break;
                }
            }
            while (!s.Equals("quit"));

            sw.Close();
            sr.Close();
            _client.Close();

            _form.Invoke(new SamDelegate(_form.RemoveSession), this);
            _form.Invoke(new SamDelegate(_form.SetText), "Disconnected " + ipe.Address.ToString());
        }

        /// <summary>
        /// fBNgƃt@C̃Xg
        /// </summary>
        /// <param name="msg">MbZ[W</param>
        /// <param name="result">s</param>
        private void CmdList(string msg, ref string result)
        {
            try
            {
                string[] str = new string[1024];
                string dir = null;
                for (int i = 0; i < Directory.GetDirectories(msg).Length; i++)
                {
                    str[i] = Directory.GetDirectories(msg)[i];
                    dir = dir + "Dir: " + "[" + str[i] + "]" + "\r\n";
                }

                for (int i = 0; i < Directory.GetFiles(msg).Length; i++)
                {
                    str[i] = Directory.GetFiles(msg)[i];
                    dir = dir + "File: " + str[i] + "\r\n";
                }
                result = dir;
            }
            catch (Exception ex)
            {
                result = ex.Message;
            }
        }

        /// <summary>
        /// tH[\܂
        /// ̃\bh͓nꂽp[^g܂
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="result"></param>
        private void ShowForm(string msg, ref string result)
        {
            _form.Invoke(new SamDelegate(_form.ShowHideForm), true);
            result = "tH[\܂B";
        }

        /// <summary>
        /// tH[B܂
        /// ̃\bh͓nꂽp[^g܂
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="result"></param>
        private void HideForm(string msg, ref string result)
        {
            _form.Invoke(new SamDelegate(_form.ShowHideForm), false);
            result = "tH[B܂B";
        }

        /// <summary>
        /// w肵t@C폜܂
        /// (폜ꍇ)
        /// </summary>
        /// <param name="msg">MbZ[W</param>
        /// <param name="result">s</param>
        private void CmdDel(string msg, ref string result)
        {
            try
            {
                File.Delete(msg);
                result = "폜܂B";
            }
            catch (Exception ex)
            {
                result = ex.Message;
            }
        }

        /// <summary>
        /// w肵t@CNCAgɓ]܂
        /// </summary>
        /// <param name="msg">MbZ[W</param>
        /// <param name="result">s</param>
        private void CmdCopy(string msg, ref string result)
        {
            try
            {
                string ip = ((IPEndPoint)_client.Client.RemoteEndPoint).Address.ToString();
                TcpClient c = new TcpClient(ip, 1889);
                NetworkStream netStream = c.GetStream();

                FileStream fs = new FileStream(msg, FileMode.Open, FileAccess.Read);
                FileInfo info = new FileInfo(msg);
                long len = info.Length;
                byte[] bb = new byte[len];
                fs.Read(bb, 0, (int)len);
                netStream.Write(bb, 0, (int)len);
                netStream.Flush();

                fs.Close();
                netStream.Close();
                c.Close();

                result = "t@CMB";
            }
            catch (Exception ex)
            {
                result = ex.Message;
            }
        }

        /// <summary>
        /// hCu擾܂
        /// ̃\bh͓nꂽp[^g܂
        /// </summary>
        /// <param name="msg">MbZ[W</param>
        /// <param name="result">s</param>
        private void CmdDriverInfo(string msg, ref string result)
        {
            ManagementObject mo = new ManagementObject();
            string[] driveType = Directory.GetLogicalDrives();
            string driveList = "";
            foreach (string drive in driveType)
            {
                mo.Path = new ManagementPath("Win32_LogicalDisk='" + drive.TrimEnd('\\') + "'");
                switch (Convert.ToInt32(mo.Properties["DriveType"].Value))
                {
                    case 0:
                        driveList = drive.Substring(0, 1) + " Unknown driver type \r\n";
                        break;
                    case 1:
                        driveList = driveList + drive.Substring(0, 1) + " no root dir\r\n";
                        break;
                    case 2:
                        driveList = driveList + drive.Substring(0, 1) + " Removable \r\n";
                        break;
                    case 3:
                        driveList = driveList + drive.Substring(0, 1) + " Hard disk \r\n";
                        break;
                    case 4:
                        driveList = driveList + drive.Substring(0, 1) + " Network disk\r\n";
                        break;
                    case 5:
                        driveList = driveList + drive.Substring(0, 1) + " CD-ROM\r\n";
                        break;
                    case 6:
                        driveList = driveList + drive.Substring(0, 1) + " RAM driver\r\n";
                        break;
                }
            }
            result = driveList;
        }

        /// <summary>
        /// w肵AvP[Vs܂
        /// </summary>
        /// <param name="msg">MbZ[W</param>
        /// <param name="result">s</param>
        private void CmdRunApp(string msg, ref string result)
        {
            try
            {
                System.Diagnostics.Process.Start(msg);
                result = "N܂B";
            }
            catch (Exception ex)
            {
                result = ex.Message;
            }
        }

        /// <summary>
        /// w肵URLI[v܂
        /// </summary>
        /// <param name="msg">MbZ[W</param>
        /// <param name="result">s</param>
        private void CmdGoToURL(string msg, ref string result)
        {
            try
            {
                System.Diagnostics.Process.Start(msg);
                result = "y[WJ܂B";
            }
            catch (Exception ex)
            {
                result = ex.Message;
            }
        }

        /// <summary>
        /// Windows o[W擾܂
        /// ̃\bh͓nꂽp[^g܂
        /// </summary>
        /// <param name="msg">MbZ[W</param>
        /// <param name="result">s</param>
        private void CmdWinVer(string msg, ref string result)
        {
            string winVer_Platform = Environment.OSVersion.Platform.ToString();
            string winVer_PlatformV = Environment.OSVersion.Version.Major.ToString();
            string winVer_build = Environment.OSVersion.Version.Build.ToString();
            string winVer = "Platform : " + winVer_Platform + "\r\n" + "PlatformVersion :" + winVer_PlatformV + "\r\n" + "Build :" + winVer_build + "\r\n";
            result = winVer;
        }

        /// <summary>
        /// XN[Lb`āA摜NCAgɓ]܂
        /// ̃\bh͓nꂽp[^g܂
        /// </summary>
        /// <param name="msg">MbZ[W</param>
        /// <param name="result">s</param>
        private void CmdGetScreen(string msg, ref string result)
        {
            Rectangle rec = Screen.PrimaryScreen.Bounds;

            Bitmap bmp = new Bitmap(rec.Width, rec.Height, PixelFormat.Format32bppArgb);
            using (Graphics g = Graphics.FromImage(bmp))
            {
                g.CopyFromScreen(rec.X, rec.Y, 0, 0, rec.Size, CopyPixelOperation.SourceCopy);
            }

            MemoryStream ms = new MemoryStream();
            bmp.Save(ms, ImageFormat.Jpeg);

            try
            {
                string ip = ((IPEndPoint)_client.Client.RemoteEndPoint).Address.ToString();
                TcpClient c = new TcpClient(ip, 1889);
                NetworkStream netStream = c.GetStream();
                ms.WriteTo(netStream);
                ms.Close();
                netStream.Close();
                c.Close();
                result = "摜M܂B";
            }
            catch (Exception ex)
            {
                result = ex.Message;
            }
        }

        /// <summary>
        /// bZ[WM
        /// </summary>
        /// <param name="msg">MbZ[W</param>
        /// <param name="result">s</param>
        private void CmdMsg(string msg, ref string result)
        {
            _form.Invoke(new SamDelegate(_form.SetText), msg);
            result = "R}hsI";
        }

        /// <summary>
        /// CDhCu䂷ׁAWin32APǏďo
        /// </summary>
        /// <param name="lpstrCommand"></param>
        /// <param name="lpstrReturnstring"></param>
        /// <param name="uReturnLength"></param>
        /// <param name="hwndCallback"></param>
        /// <returns></returns>
        [DllImport("winmm.dll", EntryPoint = "mciSendString", CharSet = CharSet.Auto)]
        public static extern int mciSendString(string lpstrCommand, string lpstrReturnstring, int uReturnLength, int hwndCallback);
        
        /// <summary>
        /// T[oCDhCuI[v/N[X
        /// (CDhCu݂)
        /// ̃\bh͓nꂽp[^g܂
        /// </summary>
        /// <param name="msg">MbZ[W</param>
        /// <param name="result">s</param>
        private void CmdCdControl(string msg, ref string result)
        {
            if (!DoorOpened)
                mciSendString("set cdaudio door open", "", 0, 0);
            if (DoorOpened)
                mciSendString("set cdaudio door closed", "", 0, 0);
            DoorOpened = !DoorOpened;
            result = "R}hs܂B";
        }
    }
}